SystemOrganization addCategory: #'KinectDollar1-Core'!

KOSampleMorph subclass: #KinectDollar1Morph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectDollar1-Core'!

!KinectDollar1Morph methodsFor: 'drawing' stamp: 'EiichiroIto 8/28/2012 09:41'!
drawOn: aCanvas
	super drawOn: aCanvas.
	aCanvas
		drawString: label
		at: self topLeft
		font: (TextStyle default fontOfSize: 20)
		color: Color black! !

!KinectDollar1Morph methodsFor: 'initialize' stamp: 'EiichiroIto 8/28/2012 09:43'!
initialize
	super initialize.
	label := '<result>'! !

!KinectDollar1Morph methodsFor: 'accessing' stamp: 'EiichiroIto 8/28/2012 09:43'!
label
	^ label! !

!KinectDollar1Morph methodsFor: 'accessing' stamp: 'EiichiroIto 8/28/2012 09:44'!
label: anObject
	label := anObject.
	self changed! !

!KinectDollar1Morph methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 21:14'!
newSkeltonMorph
	^ KDSkeltonMorph new! !

KOSkeltonMorph subclass: #KDSkeltonMorph
	instanceVariableNames: 'detector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectDollar1-Core'!

!KDSkeltonMorph methodsFor: 'initialize' stamp: 'EiichiroIto 8/27/2012 21:25'!
initialize
	super initialize.
	detector := KinectDollar1Detector new! !

!KDSkeltonMorph methodsFor: 'stepping and presenter' stamp: 'EiichiroIto 8/28/2012 18:20'!
step
	super step.
	self
		color:
			(detector isTracking
				ifTrue: [ Color lightGray ]
				ifFalse: [ Color gray ]).
	detector skelton: skelton recognizedDo: [ :result | owner label: 'User' , skelton id asString , '-' , result first ]! !

Object subclass: #KinectDollar1Detector
	instanceVariableNames: 'points recognizer sampleJoint mode count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinectDollar1-Core'!

!KinectDollar1Detector methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 21:19'!
addPoint: aPoint
	points add: aPoint! !

!KinectDollar1Detector methodsFor: 'private-transition' stamp: 'EiichiroIto 8/28/2012 10:13'!
countEnd: aPoint
	(self isMoving: aPoint)
		ifTrue: [ 
			mode := #tracking.
			^ self tracking: aPoint ].
	count := count + 1.
	count > self countEndThresold
		ifTrue: [ mode := #complete ]! !

!KinectDollar1Detector methodsFor: 'private' stamp: 'EiichiroIto 8/28/2012 10:29'!
countEndThresold
	^ 5! !

!KinectDollar1Detector methodsFor: 'private-transition' stamp: 'EiichiroIto 8/28/2012 10:22'!
countStart: aPoint
	(self isMoving: aPoint)
		ifTrue: [ ^ self newPoint: aPoint ].
	count := count + 1.
	count > self countStartThresold
		ifTrue: [ mode := #tracking ]! !

!KinectDollar1Detector methodsFor: 'private' stamp: 'EiichiroIto 8/28/2012 10:29'!
countStartThresold
	^ 3! !

!KinectDollar1Detector methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 21:30'!
defaultSampleJoint
	^ #l_hand! !

!KinectDollar1Detector methodsFor: 'initialize-release' stamp: 'EiichiroIto 8/28/2012 10:19'!
initialize
	recognizer := Dollar1Recognizer new.
	sampleJoint := self defaultSampleJoint.
	self resetTransition! !

!KinectDollar1Detector methodsFor: 'testing' stamp: 'EiichiroIto 8/28/2012 10:03'!
isMoving: aPoint
	^ (aPoint - points last) abs > self pointThreshold! !

!KinectDollar1Detector methodsFor: 'testing' stamp: 'EiichiroIto 8/28/2012 10:27'!
isTracking
	^ mode = #tracking or: [ mode = #countEnd ]! !

!KinectDollar1Detector methodsFor: 'private' stamp: 'EiichiroIto 8/28/2012 10:19'!
newPoint: aPoint
	self resetTransition.
	self addPoint: aPoint! !

!KinectDollar1Detector methodsFor: 'private' stamp: 'EiichiroIto 8/27/2012 21:02'!
pointThreshold
	^ 0.01 @ 0.01! !

!KinectDollar1Detector methodsFor: 'private-transition' stamp: 'EiichiroIto 8/28/2012 10:21'!
resetTransition
	points := OrderedCollection new.
	mode := #waiting.
	count := 0! !

!KinectDollar1Detector methodsFor: 'accessing' stamp: 'EiichiroIto 8/28/2012 18:19'!
skelton: aSkelton recognizedDo: aBlock
	| neck sample dx dy dz ret |
	neck := aSkelton jointNamed: #neck.
	neck ifNil: [ ^ self ].
	sample := aSkelton jointNamed: sampleJoint.
	sample ifNil: [ ^ self ].
	dx := sample x - neck x + 1.0.
	dy := sample y - neck y + 1.0.
	dz := sample z - neck z.
	dz > -0.2
		ifTrue: [ ^ self resetTransition ].
	self perform: (mode , ':') asSymbol with: dx @ dy.
	mode = #complete
		ifTrue: [ 
			ret := recognizer recognize: points.
			self resetTransition.
			aBlock value: ret ]! !

!KinectDollar1Detector methodsFor: 'private' stamp: 'EiichiroIto 8/28/2012 10:16'!
status
	^ 'mode=' , mode , ',count=' , count asString , ',points=' , points size asString! !

!KinectDollar1Detector methodsFor: 'private-transition' stamp: 'EiichiroIto 8/28/2012 10:15'!
tracking: aPoint
	(self isMoving: aPoint)
		ifTrue: [ self addPoint: aPoint ]
		ifFalse: [ 
			points size > 1
				ifTrue: [ 
					mode := #countEnd.
					count := 0 ] ]! !

!KinectDollar1Detector methodsFor: 'private-transition' stamp: 'EiichiroIto 8/28/2012 10:08'!
waiting: aPoint
	points isEmpty
		ifTrue: [ ^ self addPoint: aPoint ].
	(self isMoving: aPoint)
		ifTrue: [ self newPoint: aPoint ]
		ifFalse: [ 
			mode := #countStart.
			count := 0 ]! !
